﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.Text;


public partial class _Default : System.Web.UI.Page 
{
	// 读Cookie时注意检查Cookie值，尤其是需要类型转换或者反序列化时，因为现在浏览器允许直接修改它们。

	protected override void OnLoad(EventArgs e)
	{
		base.OnLoad(e);

		ReadCookie();

		ReadCookie_2a();

		ReadCookie_2b();

		ReadEncryCookie();

		ReadSession();
		
		this.labStatus.Text = (Request.IsAuthenticated ? "已登录" : "未登录");

		ShowAllCookies();
	}


	private void ReadCookie()
	{
		HttpCookie cookie = Request.Cookies["cookie_1"];
		if( cookie != null )
			labCookie1.Text = cookie.Value;
		else
			labCookie1.Text = "未定义";
	}



	private void ReadCookie_2a()
	{
		HttpCookie cookie = Request.Cookies["DisplaySettings1"];
		if( cookie == null )
			labDisplaySettings1.Text = "未定义";
		else {
			DisplaySettings setting = new DisplaySettings();
			setting.Style = cookie["Style"].TryToInt();
			setting.Size = cookie["Size"].TryToInt();
			labDisplaySettings1.Text = setting.ToString();
		}
	}


	private void ReadCookie_2b()
	{
		HttpCookie cookie = Request.Cookies["DisplaySettings2"];
		if( cookie == null )
			labDisplaySettings2.Text = "未定义";
		else {
			DisplaySettings setting = cookie.Value.FromJson<DisplaySettings>();
			labDisplaySettings2.Text = setting.ToString();
		}
	}
	

	private void ReadEncryCookie()
	{
		HttpCookie cookie = Request.Cookies["encString"];
		if( cookie == null )
			labCookie2.Text = "未定义";
		else {
			try {
				FormsAuthenticationTicket ticket = FormsAuthentication.Decrypt(cookie.Value);
				labCookie2.Text = ticket.UserData;
			}
			catch {
				labCookie2.Text = "无效的Cookie值。";
			}
		}
	}


	private void ReadSession()
	{
		object obj = Session["Key1"];
		if( obj == null )
			labSession.Text = "未定义";
		else
			labSession.Text = obj.ToString();

	}

	private void ShowAllCookies()
	{
		StringBuilder sb = new StringBuilder();

		for( int i = 0; i < Request.Cookies.Count; i++ ) {
			HttpCookie cookie = Request.Cookies[i];
			sb.AppendFormat("{0}={1}, {2}, {3}, {4}<br />", cookie.Name, cookie.Value, cookie.Domain, cookie.Path, cookie.Expires.ToString());
		}

		labAllCookies.Text = sb.ToString();
	}

}
